#
# Red Hat BIND package .spec file
#
%define __lnsf ln -sf

#%%global PATCHVER P2
#%%global PREVER rc2
#%%global VERSION %{version}%{PREVER}
%global VERSION %{version}
#%%global VERSION %{version}-%{PATCHVER}

%{?!SDB:       %global SDB       1}
%{?!test:      %global test      0}
%{?!bind_uid:  %global bind_uid  25}
%{?!bind_gid:  %global bind_gid  25}
%{?!GSSTSIG:   %global GSSTSIG   1}
%{?!PKCS11:    %global PKCS11    1}
%{?!DEVEL:     %global DEVEL     1}
%{?!GEOIP:     %global GEOIP     1}
%define        bind_dir          /var/named
%define        chroot_prefix     %{bind_dir}/chroot
%define        bind_etc          %{bind_dir}/etc
#
Summary:  The Berkeley Internet Name Domain (BIND) applied chroot
Summary(ko): Chroot가 적용된 버클리 인터넷 네임 서버 (BIND)
Name:     bind
License:  ISC
Version:  9.9.4
Release:  29%{?PATCHVER}%{?PREVER}%{?dist}.4
Epoch:    132
Url:      http://www.isc.org/products/BIND/
Buildroot:%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Group:    System Environment/Daemons
#
Source:   ftp://ftp.isc.org/isc/bind9/%{VERSION}/bind-%{VERSION}.tar.gz
Source1:  named.sysconfig
Source3:  named.logrotate
Source4:  named.NetworkManager
Source5:  rfc1912.txt
Source7:  bind-9.3.1rc1-sdb_tools-Makefile.in
Source8:  dnszone.schema
Source12: README.sdb_pgsql
Source21: Copyright.caching-nameserver
Source25: named.conf.sample
Source28: config-12.tar.bz2
Source30: ldap2zone.c
Source31: ldap2zone.1
Source32: named-sdb.8
Source33: zonetodb.1
Source34: zone2sqlite.1

Source35: bind.tmpfiles.d
Source37: named.service
Source43: named.rwtab

Source36: named.root.key

#AnNyung Source
Source100: rndc-confkey
Source101: keygen.c
Source102: named-start-pre

# Common patches
Patch5:  bind-nonexec.patch
Patch10: bind-9.5-PIE.patch
Patch16: bind-9.3.2-redhat_doc.patch
Patch72: bind-9.5-dlz-64bit.patch
Patch87: bind-9.5-parallel-build.patch
Patch101:bind-96-old-api.patch
Patch102:bind-95-rh452060.patch
Patch106:bind93-rh490837.patch
Patch109:bind97-rh478718.patch
Patch110:bind97-rh570851.patch
Patch111:bind97-exportlib.patch
Patch112:bind97-rh645544.patch
Patch119:bind97-rh693982.patch
Patch123:bind98-rh735103.patch
Patch124:nslookup-norec.patch
Patch125:bind99-buildfix.patch
Patch127:bind99-forward.patch
Patch130:bind-9.9.1-P2-dlz-libdb.patch
Patch131:bind-9.9.1-P2-multlib-conflict.patch
Patch133:bind99-rh640538.patch
Patch134:bind97-rh669163.patch
Patch137:bind99-rrl.patch
# Install dns/update.h header for bind-dyndb-ldap plugin
Patch138:bind-9.9.3-include-update-h.patch
Patch139:bind99-ISC-Bugs-34738.patch
Patch140:bind99-ISC-Bugs-34870-v3.patch
Patch141:bind99-ISC-Bugs-35073.patch
Patch142:bind99-ISC-Bugs-35080.patch
Patch143:bind99-CVE-2014-0591.patch
Patch144:bind99-rh1067424.patch
Patch145:bind99-rh1072379.patch
Patch146:bind99-rh1098959.patch
Patch147:bind99-CVE-2014-8500.patch
Patch148:bind99-CVE-2015-1349.patch

Patch149:bind99-rh1215687-limits.patch
Patch154:bind99-rh1215164.patch
Patch155:bind99-rh1214827.patch
Patch156:bind99-CVE-2015-4620.patch
Patch157:bind99-CVE-2015-5477.patch
Patch158:bind-99-socket-maxevents.patch
Patch159:bind99-CVE-2015-5722.patch
Patch160:bind99-CVE-2015-8000.patch
Patch161:bind99-CVE-2015-8704.patch
Patch162:bind99-CVE-2016-1285-CVE-2016-1286.patch
patch163:bind99-CVE-2016-2776.patch

# Native PKCS#11 functionality from 9.10
Patch150:bind-9.9-allow_external_dnskey.patch
Patch151:bind-9.9-native-pkcs11.patch
Patch152:bind-9.9-dist-native-pkcs11.patch
Patch153:bind99-coverity-fixes.patch

# SDB patches
Patch11: bind-9.3.2b2-sdbsrc.patch
Patch12: bind-9.5-sdb.patch
Patch62: bind-9.5-sdb-sqlite-bld.patch

# needs inpection
Patch17: bind-9.3.2b1-fix_sdb_ldap.patch
Patch104: bind-96-dyndb.patch
Patch105: bind-99-dyndb-rh1142150.patch

# IDN paches
Patch73: bind-9.5-libidn.patch
Patch83: bind-9.5-libidn2.patch
Patch85: bind-9.5-libidn3.patch
Patch94: bind95-rh461409.patch
Patch135:bind99-libidn4.patch

# AnNyung Patch
Patch999: bind-9.9.4-geoip-1.4.patch
Patch1000: bind-annyung-static-util.patch
Patch1001: bind-annyung-multicname.patch
Patch1002: bind-annyung-config-idn.patch

#
Requires(preun):  systemd
Requires(postun): systemd
Requires:       coreutils
Requires:       systemd-units
Requires(post): grep, systemd
Requires(pre):  shadow-utils
Requires:       bind-libs = %{epoch}:%{version}-%{release}
Obsoletes:      bind-config < 30:9.3.2-34.fc6
Provides:       bind-config = 30:9.3.2-34.fc6
Obsoletes:      caching-nameserver < 31:9.4.1-7.fc8
Provides:       caching-nameserver = 31:9.4.1-7.fc8
Obsoletes:      dnssec-conf < 1.27-2
Provides:       dnssec-conf = 1.27-1
BuildRequires:  openssl-devel, libtool, autoconf, pkgconfig, libcap-devel
BuildRequires:  libidn-devel, libxml2-devel olibc-devel >= 1.0.0
%if %{SDB}
BuildRequires:  openldap-devel, postgresql-devel, sqlite-devel, mysql-devel
BuildRequires:  libdb-devel
%endif
%if %{test}
BuildRequires:  net-tools
%endif
%if %{GSSTSIG}
BuildRequires:  krb5-devel
%endif
# Needed to regenerate dig.1 manpage
BuildRequires: docbook-style-xsl, libxslt
%if %{GEOIP}
BuildRequires: GeoIP-devel
%endif

%description
BIND (Berkeley Internet Name Domain) is an implementation of the DNS
(Domain Name System) protocols. BIND includes a DNS server (named),
which resolves host names to IP addresses; a resolver library
(routines for applications to use when interfacing with DNS); and
tools for verifying that the DNS server is operating properly.

%if %{PKCS11}
%package pkcs11
Summary: Bind with native PKCS#11 functionality for crypto
Summary(ko): 암호화를 위한 BIND 내장 PKCS#11 기능
Group:   System Environment/Daemons
Requires: bind = %{epoch}:%{version}-%{release}
Requires: bind-pkcs11-libs = %{epoch}:%{version}-%{release}

%description pkcs11
This is a version of BIND server built with native PKCS#11 functionality.
It is important to have SoftHSM v2+ installed and some token initialized.
For other supported HSM modules please check the BIND documentation.
This version of BIND binary is supported only in setup with the IPA server.

%package pkcs11-utils
Summary: Bind tools with native PKCS#11 for using DNSSEC
Summary(ko): DNSSEC를 사용하기 위한 BIND 내장 PKCS#11 도구
Group:   System Environment/Daemons
Requires: bind-pkcs11-libs = %{epoch}:%{version}-%{release}

%description pkcs11-utils
This is a set of PKCS#11 utilities that when used together create rsa
keys in a PKCS11 keystore. Also utilities for working with DNSSEC
compiled with native PKCS#11 functionality are included.

%package pkcs11-libs
Summary: Bind libraries compiled with native PKCS#11
Group:   System Environment/Daemons
Requires: bind-license = %{epoch}:%{version}-%{release}
Requires: bind-libs = %{epoch}:%{version}-%{release}

%description pkcs11-libs
This is a set of BIND libraries (dns, isc) compiled with native PKCS#11
functionality.

%package pkcs11-devel
Summary: Development files for Bind libraries compiled with native PKCS#11
Group:   System Environment/Daemons
Requires: bind-pkcs11-libs = %{epoch}:%{version}-%{release}

%description pkcs11-devel
This a set of development files for BIND libraries (dns, isc) compiled
with native PKCS#11 functionality.
%endif

%if %{SDB}
%package sdb
Summary: BIND server with database backends and DLZ support
Summary(ko): 데이터베이스 백엔드와 DLZ를 지원하는 BIND 서버
Group:   System Environment/Daemons
Requires: bind-libs = %{epoch}:%{version}-%{release}


%description sdb
BIND (Berkeley Internet Name Domain) is an implementation of the DNS
(Domain Name System) protocols. BIND includes a DNS server (named-sdb)
which has compiled-in SDB (Simplified Database Backend) which includes
support for using alternative Zone Databases stored in an LDAP server
(ldapdb), a postgreSQL database (pgsqldb), an sqlite database (sqlitedb),
or in the filesystem (dirdb), in addition to the standard in-memory RBT
(Red Black Tree) zone database. It also includes support for DLZ
(Dynamic Loadable Zones)
%endif

%package libs-lite
Summary:  Libraries for working with the DNS protocol
Summary(ko): DNS 프로토콜 동작을 위한 라이브러리
Group:    Applications/System
Obsoletes:bind-libbind-devel < 31:9.3.3-4.fc7
Provides: bind-libbind-devel = 31:9.3.3-4.fc7
Requires: bind-license = %{epoch}:%{version}-%{release}
%if %{GEOIP}
Requires:       GeoIP
%endif

%description libs-lite
Contains lite version of BIND suite libraries which are used by various
programs to work with DNS protocol.

%package libs
Summary:  Libraries used by the BIND DNS packages
Summary(ko): BIND DNS에 필요한 라이브러리
Group:    Applications/System
Requires: bind-license = %{epoch}:%{version}-%{release}
%if %{GEOIP}
Requires:       GeoIP
%endif

%description libs
Contains heavyweight version of BIND suite libraries used by both named DNS
server and utilities in bind-utils package.

%package license
Summary:  License of the BIND DNS suite
Summary(ko): BIND DNS 라이센스
Group:    Applications/System
BuildArch:noarch

%description license
Contains license of the BIND DNS suite.

%package utils
Summary: Utilities for querying DNS name servers
Summary(ko): DNS 서버에 질의를 하기 위한 도구
Group:   Applications/System
Requires:bind-libs = %{epoch}:%{version}-%{release}

%description utils
Bind-utils contains a collection of utilities for querying DNS (Domain
Name System) name servers to find out information about Internet
hosts. These tools will provide you with the IP addresses for given
host names, as well as other information about registered domains and
network addresses.

You should install bind-utils if you need to get information from DNS name
servers.

%if %{DEVEL}
%package devel
Summary:  Header files and libraries needed for BIND DNS development
Summary(ko): BIND DNS 개발을 위해 필요한 헤더 파일과 라이브러리
Group:    Development/Libraries
Obsoletes:bind-libbind-devel < 31:9.3.3-4.fc7
Provides: bind-libbind-devel = 31:9.3.3-4.fc7
Requires: bind-libs = %{epoch}:%{version}-%{release}
%if %{GEOIP}
Requires:       GeoIP-devel
%endif

%description devel
The bind-devel package contains full version of the header files and libraries
required for development with ISC BIND 9
%endif

%package lite-devel
Summary:  Lite version of header files and libraries needed for BIND DNS development
Summary(ko): BIND DNS 개발을 위해 필요한 최소 헤더파일 및 라이브러리
Group:    Development/Libraries
Requires: bind-libs-lite = %{epoch}:%{version}-%{release}
%if %{GEOIP}
Requires:       GeoIP-devel
%endif

%description lite-devel
The bind-lite-devel package contains lite version of the header
files and libraries required for development with ISC BIND 9

%prep
%setup -q -n %{name}-%{VERSION}

# Common patches
%patch5 -p1 -b .nonexec
%patch10 -p1 -b .PIE
%patch16 -p1 -b .redhat_doc
%patch104 -p1 -b .dyndb
%patch105 -p1 -b .dyndb_rh1142150
%ifnarch alpha ia64
%patch72 -p1 -b .64bit
%endif
%patch73 -p1 -b .libidn
%patch83 -p1 -b .libidn2
%patch85 -p1 -b .libidn3
%patch87 -p1 -b .parallel
%patch94 -p1 -b .rh461409

%patch102 -p1 -b .rh452060
%patch106 -p0 -b .rh490837
%patch109 -p1 -b .rh478718
%patch110 -p1 -b .rh570851
%patch111 -p1 -b .exportlib
%patch112 -p1 -b .rh645544
%patch119 -p1 -b .rh693982
%patch123 -p1 -b .rh735103
pushd bin/dig
%patch124 -p0 -b .nslookup-norec
popd
%patch125 -p1 -b .buildfix
%patch127 -p1 -b .forward
%patch130 -p1 -b .libdb
%patch131 -p1 -b .multlib-conflict
%patch137 -p1 -b .rrl
%patch138 -p1 -b .update
%patch139 -p1 -b .journal
%patch140 -p1 -b .send_buffers
%patch141 -p1 -b .leak_35073
%patch142 -p1 -b .rbt_crash
%patch143 -p1 -b .CVE-2014-059
%patch144 -p1 -b .rh1067424
%patch145 -p1 -b .rh1072379
%patch146 -p1 -b .rh1098959
%patch147 -p1 -b .CVE-2014-8500
%patch148 -p1 -b .CVE-2015-1349
%patch149 -p1 -b .rh1215687-limits

%patch150 -p1 -b .external_key
%patch151 -p1 -b .native_pkcs11
# http://cov01.lab.eng.brq.redhat.com/covscanhub/waiving/9377/
%patch153 -p1 -b .coverity_9377
%patch154 -p1 -b .rh1215164
%patch155 -p1 -b .nsupdate_realm
%patch156 -p1 -b .CVE-2015-4620
%patch157 -p1 -b .CVE-2015-5477
%patch158 -p1 -b .sock-maxevents
%patch159 -p1 -b .CVE-2015-5722
%patch160 -p1 -b .CVE-2015-8000
%patch161 -p1 -b .CVE-2015-8704
%patch162 -p1 -b .CVE-2016-1285-CVE-2016-1286
%patch163 -p1 -b .CVE-2016-2776

%if %{PKCS11}
cp -r bin/named{,-pkcs11}
cp -r bin/dnssec{,-pkcs11}
cp -r lib/isc{,-pkcs11}
cp -r lib/dns{,-pkcs11}
cp -r lib/export/isc{,-pkcs11}
cp -r lib/export/dns{,-pkcs11}
%patch152 -p1 -b .dist_pkcs11
%endif

%if %{SDB}
%patch101 -p1 -b .old-api
mkdir bin/named-sdb
cp -r bin/named/* bin/named-sdb
%patch11 -p1 -b .sdbsrc
# SDB ldap
cp -fp contrib/sdb/ldap/ldapdb.[ch] bin/named-sdb
# SDB postgreSQL
cp -fp contrib/sdb/pgsql/pgsqldb.[ch] bin/named-sdb
# SDB sqlite
cp -fp contrib/sdb/sqlite/sqlitedb.[ch] bin/named-sdb
# SDB Berkeley DB - needs to be ported to DB4!
#cp -fp contrib/sdb/bdb/bdb.[ch] bin/named_sdb
# SDB dir
cp -fp contrib/sdb/dir/dirdb.[ch] bin/named-sdb
# SDB tools
mkdir -p bin/sdb_tools
cp -fp %{SOURCE30} bin/sdb_tools/ldap2zone.c
cp -fp %{SOURCE7} bin/sdb_tools/Makefile.in
#cp -fp contrib/sdb/bdb/zone2bdb.c bin/sdb_tools
cp -fp contrib/sdb/ldap/{zone2ldap.1,zone2ldap.c} bin/sdb_tools
cp -fp contrib/sdb/pgsql/zonetodb.c bin/sdb_tools
cp -fp contrib/sdb/sqlite/zone2sqlite.c bin/sdb_tools
%patch12 -p1 -b .sdb
%endif
%if %{SDB}
%patch17 -p1 -b .fix_sdb_ldap
%endif
%if %{SDB}
%patch62 -p1 -b .sdb-sqlite-bld
%endif
%patch133 -p1 -b .rh640538
%patch134 -p1 -b .rh669163
%patch135 -p1 -b .libidn4

# AnNyung patch
%if %{GEOIP}
%patch999 -p1
%endif
%patch1000 -p1
%patch1001 -p1
%patch1002 -p1

# Sparc and s390 arches need to use -fPIE
%ifarch sparcv9 sparc64 s390 s390x
for i in bin/named{,-sdb}/{,unix}/Makefile.in; do
	sed -i 's|fpie|fPIE|g' $i
done
%endif

:;

%build
export CFLAGS="$CFLAGS $RPM_OPT_FLAGS"
export CPPFLAGS="$CPPFLAGS -DDIG_SIGCHASE"
export STD_CDEFINES="$CPPFLAGS"

sed -i -e \
's/RELEASEVER=\(.*\)/RELEASEVER=\1-RedHat-%{version}-%{release}/' \
version

libtoolize -c -f; aclocal -I m4 --force; autoconf -f

%configure \
  --with-libtool \
  --localstatedir=/var \
  --enable-threads \
  --enable-ipv6 \
  --enable-filter-aaaa \
  --enable-rrl \
  --with-pic \
  --disable-static \
  --disable-openssl-version-check \
  --enable-exportlib \
  --with-export-libdir=%{_libdir} \
  --with-export-includedir=%{_includedir} \
  --includedir=%{_includedir}/bind9 \
%if %{PKCS11}
  --enable-native-pkcs11 \
  --with-pkcs11=%{_libdir}/pkcs11/libsofthsm2.so \
%endif
%if %{SDB}
  --with-dlopen=yes \
  --with-dlz-ldap=yes \
  --with-dlz-postgres=yes \
  --with-dlz-mysql=yes \
  --with-dlz-filesystem=yes \
  --with-dlz-bdb=yes \
%endif
%if %{GSSTSIG}
  --with-gssapi=yes \
  --disable-isc-spnego \
%endif
%if %{GEOIP}
  --with-geoip \
%endif
  --enable-fixed-rrset \
  --with-docbook-xsl=%{_datadir}/sgml/docbook/xsl-stylesheets \
;
make %{?_smp_mflags}

# Regenerate dig.1 manpage
pushd bin/dig
make man
popd
pushd bin/nsupdate
make man
popd

pushd doc/arm
make Bv9ARM.html
popd

# Remove this backup file to avoid be picked by %%doc directive
rm -f doc/arm/Bv9ARM-book.xml.rh873624
 
%if %{test}
%check
if [ "`whoami`" = 'root' ]; then
  set -e
  chmod -R a+rwX .
  pushd bin/tests
  pushd system
  ./ifconfig.sh up
  popd
  make test
  e=$?
  pushd system
  ./ifconfig.sh down
  popd
  popd
  if [ "$e" -ne 0 ]; then
    echo "ERROR: this build of BIND failed 'make test'. Aborting."
    exit $e;
  fi;
else
  echo 'only root can run the tests (they require an ifconfig).'
%endif

%install
rm -rf ${RPM_BUILD_ROOT}

# We don't want these
#rm -f doc/rfc/fetch

#cp  --preserve=timestamps %{SOURCE5} doc/rfc
#gzip -9 doc/rfc/*

# Build directory hierarchy
mkdir -p ${RPM_BUILD_ROOT}/etc/portreserve
%{__mkdir_p} %{buildroot}%{_sysconfdir}/{sysconfig,rc.d/init.d}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/{logrotate.d,NetworkManager/dispatcher.d}
%{__mkdir_p} %{buildroot}%{_var}/{named,log}
%{__mkdir_p} %{buildroot}/run
%{__mkdir_p} %{buildroot}%{_libdir}/bind
%{__mkdir_p} %{buildroot}%{_mandir}/{man1,man5,man8}

%if %{GEOIP}
%{__mkdir_p} %{buildroot}%{_var}/named/usr/share/GeoIP
%endif

pushd %{buildroot}%{_var}/named
   tar xvfpj %{SOURCE28}
popd

pushd %{buildroot}%{_sysconfdir}
   %{__lnsf} ../var/named/etc named
popd

pushd %{buildroot}%{_var}/log
   %{__lnsf} ../named/log named
popd

pushd %{buildroot}/run
	%{__lnsf} /var/named/run named
popd

make DESTDIR=${RPM_BUILD_ROOT} install

# Remove unwanted files
rm -f ${RPM_BUILD_ROOT}/etc/bind.keys

# Systemd unit files
mkdir -p ${RPM_BUILD_ROOT}%{_unitdir}
install -m 644 %{SOURCE37} ${RPM_BUILD_ROOT}%{_unitdir}

install -m 644 %SOURCE3 ${RPM_BUILD_ROOT}/etc/logrotate.d/named
install -m 755 %SOURCE4 ${RPM_BUILD_ROOT}/etc/NetworkManager/dispatcher.d/13-named
install -m 644 %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/named
%if %{SDB}
mkdir -p ${RPM_BUILD_ROOT}/etc/openldap/schema
install -m 644 %{SOURCE8} ${RPM_BUILD_ROOT}/etc/openldap/schema/dnszone.schema
install -m 644 %{SOURCE12} contrib/sdb/pgsql/
%endif

# Files required to run test-suite outside of build tree:
cp -fp config.h ${RPM_BUILD_ROOT}/%{_includedir}/bind9
cp -fp lib/dns/include/dns/forward.h ${RPM_BUILD_ROOT}/%{_includedir}/dns
cp -fp lib/isc/unix/include/isc/keyboard.h ${RPM_BUILD_ROOT}/%{_includedir}/isc

# Remove libtool .la files:
find ${RPM_BUILD_ROOT}/%{_libdir} -name '*.la' -exec '/bin/rm' '-f' '{}' ';';
# /usr/lib/rpm/brp-compress
#

%if !%{DEVEL}
rm -f ${RPM_BUILD_ROOT}/%{_libdir}/bind9/*so
rm -rf ${RPM_BUILD_ROOT}/%{_includedir}/bind9
rm -f ${RPM_BUILD_ROOT}/%{_mandir}/man1/isc-config.sh.1*
rm -f ${RPM_BUILD_ROOT}/%{_mandir}/man3/lwres*
rm -f ${RPM_BUILD_ROOT}/%{_bindir}/isc-config.sh
%endif

# SDB manpages
%if %{SDB}
install -m 644 %{SOURCE31} ${RPM_BUILD_ROOT}%{_mandir}/man1/ldap2zone.1
install -m 644 %{SOURCE32} ${RPM_BUILD_ROOT}%{_mandir}/man8/named-sdb.8
install -m 644 %{SOURCE33} ${RPM_BUILD_ROOT}%{_mandir}/man1/zonetodb.1
install -m 644 %{SOURCE34} ${RPM_BUILD_ROOT}%{_mandir}/man1/zone2sqlite.1
%endif

# PKCS11 versions manpages
%if %{PKCS11}
pushd ${RPM_BUILD_ROOT}%{_mandir}/man8
ln -s named.8.gz named-pkcs11.8.gz
ln -s dnssec-checkds.8.gz dnssec-checkds-pkcs11.8.gz
ln -s dnssec-coverage.8.gz dnssec-coverage-pkcs11.8.gz
ln -s dnssec-dsfromkey.8.gz dnssec-dsfromkey-pkcs11.8.gz
ln -s dnssec-keyfromlabel.8.gz dnssec-keyfromlabel-pkcs11.8.gz
ln -s dnssec-keygen.8.gz dnssec-keygen-pkcs11.8.gz
ln -s dnssec-revoke.8.gz dnssec-revoke-pkcs11.8.gz
ln -s dnssec-settime.8.gz dnssec-settime-pkcs11.8.gz
ln -s dnssec-signzone.8.gz dnssec-signzone-pkcs11.8.gz
ln -s dnssec-verify.8.gz dnssec-verify-pkcs11.8.gz
popd
%endif

# configuration files:
install -m 644 bind.keys %{buildroot}%{bind_etc}/named.iscdlv.key
install -m 644 %{SOURCE36} %{buildroot}%{bind_etc}/named.root.key

install -m 644 %{SOURCE5}  ./rfc1912.txt
install -m 644 %{SOURCE21} ./Copyright

install -m 700 %{SOURCE100} %{buildroot}%{_sbindir}/rndc-confkey

# dns-keygen
%{__cc} $RPM_OPT_FLAGS -o %{buildroot}%{_sbindir}/dns-keygen %{SOURCE101}

%{__mkdir_p} %{buildroot}%{_tmpfilesdir}
install -m 644 %{SOURCE35} ${RPM_BUILD_ROOT}%{_tmpfilesdir}/named.conf

%{__mkdir_p} %{buildroot}%{_sysconfdir}/rwtab.d
install -m 644 %{SOURCE43} ${RPM_BUILD_ROOT}%{_sysconfdir}/rwtab.d/named

# install start-pre/stop-post script
%{__mkdir_p} %{buildroot}%{_datadir}/bind
install -m 755 %{SOURCE102} %{buildroot}%{_datadir}/bind/


%pre
if [ "$1" -eq 1 ]; then
  /usr/sbin/groupadd -g %{bind_gid} -f -r named >/dev/null 2>&1 || :;
  /usr/sbin/useradd  -u %{bind_uid} -r -N -M -g named -G 2 -s /sbin/nologin -d %{bind_dir} -c Named named >/dev/null 2>&1 || :;
fi;
:;

%post
/sbin/ldconfig
%systemd_post named.service
if [ "$1" -eq 1 ]; then
	/usr/bin/systemctl enable named.service >& /dev/null || :
fi
/usr/sbin/rndc-confkey
if [ "$1" -eq 1 ]; then
  # Initial installation
  [ -x /sbin/restorecon ] && /sbin/restorecon /etc/named/rndc.* /etc/named/named.* >/dev/null 2>&1 ;
  # rndc.key has to have correct perms and ownership, CVE-2007-6283
  [ -e /etc/named/rndc.key ] && chown root:named /etc/named/rndc.key
  [ -e /etc/named/rndc.key ] && chmod 0640 /etc/named/rndc.key
fi
:;

%preun
# Package removal, not upgrade
%systemd_preun named.service

%postun
/sbin/ldconfig
 Package upgrade, not uninstall
%systemd_postun_with_restart named.service

%triggerpostun -n bind -- bind <= 32:9.5.0-20.b1
if [ "$1" -gt 0 ]; then
  [ -e /etc/named/rndc.key ] && chown root:named /etc/named/rndc.key
  [ -e /etc/named/rndc.key ] && chmod 0640 /etc/named/rndc.key
fi
:;

%triggerun -- bind < 32:9.9.0-0.6.rc1
/sbin/chkconfig --del named >/dev/null 2>&1 || :
/bin/systemctl try-restart named.service >/dev/null 2>&1 || :

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post libs-lite -p /sbin/ldconfig

%postun libs-lite -p /sbin/ldconfig

%clean
rm -rf ${RPM_BUILD_ROOT}
:;

%files
%defattr(-,root,root,-)
#{_libdir}/bind
%dir %{bind_dir}
%dir %{bind_dir}/dev
%dir %{bind_dir}/usr
%if %{GEOIP}
%dir %{bind_dir}/usr/share/GeoIP
%endif
%dir %{bind_dir}/zone
%dir %{_datadir}/bind
%{_datadir}/bind/named-*
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sysconfig/named
%config(noreplace) %attr(-,root,named) %{bind_etc}/named.iscdlv.key
%config(noreplace) %attr(-,root,named) %{bind_etc}/named.root.key
%{bind_dir}/dev/*
%{_tmpfilesdir}/named.conf
%{_sysconfdir}/rwtab.d/named
%{_unitdir}/named.service
%{_sysconfdir}/NetworkManager/dispatcher.d/13-named
#{_sysconfdir}/portreserve/named
%{_sbindir}/arpaname
%{_sbindir}/ddns-confgen
%{_sbindir}/genrandom
%{_sbindir}/named-journalprint
%{_sbindir}/nsec3hash
%{_sbindir}/dnssec*
%exclude %{_sbindir}/dnssec*pkcs11
%{_sbindir}/named-check*
%{_sbindir}/lwresd
%{_sbindir}/named
%{_sbindir}/rndc*
%{_sbindir}/named-compilezone
%{_sbindir}/isc-hmac-fixup
%{_sbindir}/dns-keygen
%{_mandir}/man1/arpaname.1*
%{_mandir}/man5/named.conf.5*
%{_mandir}/man5/rndc.conf.5*
%{_mandir}/man8/rndc.8*
%{_mandir}/man8/named.8*
%{_mandir}/man8/lwresd.8*
%{_mandir}/man8/dnssec*.8*
%exclude %{_mandir}/man8/dnssec*-pkcs11.8*
%{_mandir}/man8/named-checkconf.8*
%{_mandir}/man8/named-checkzone.8*
%{_mandir}/man8/named-compilezone.8*
%{_mandir}/man8/rndc-confgen.8*
%{_mandir}/man8/ddns-confgen.8*
%{_mandir}/man8/genrandom.8*
%{_mandir}/man8/named-journalprint.8*
%{_mandir}/man8/nsec3hash.8*
%{_mandir}/man8/isc-hmac-fixup.8*
%doc CHANGES README
%doc doc/arm/*html doc/arm/*pdf

# Hide configuration
%defattr(0640,root,named,0750)
%{_sysconfdir}/named
%config(noreplace) %verify(not link) %{bind_etc}/named.conf
%config(noreplace) %verify(not link) %{bind_etc}/named.acl.conf
%config(noreplace) %verify(not link) %{bind_etc}/named.user.zones
%config(noreplace) %verify(not link) %{bind_etc}/named.rfc1912.zones
%config(noreplace) %{bind_etc}/rndc.key
%config(noreplace) %{bind_etc}/rndc.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/named
%config %verify(not link) %{bind_dir}/zone/global/named.ca
%config %verify(not link) %{bind_dir}/zone/local/named.localhost
%config %verify(not link) %{bind_dir}/zone/reverse/named.loopback
%config %verify(not link) %{bind_dir}/zone/reverse/named.empty
%defattr(0660,named,named,0770)
%dir %{bind_dir}/log
%dir %{bind_dir}/run
%dir %{bind_dir}/zone/slaves
%dir %{bind_dir}/zone/dynamic
%dir %{bind_etc}/pki
%dir %{bind_etc}/pki/dnssec-keys
%defattr(-,root,named,-)
%{_localstatedir}/log/named
/run/named

%if %{SDB}
%files sdb
%defattr(-,root,root,-)
%{_mandir}/man1/zone2ldap.1*
%{_mandir}/man1/ldap2zone.1*
%{_mandir}/man1/zonetodb.1*
%{_mandir}/man1/zone2sqlite.1*
%{_mandir}/man8/named-sdb.8*
%doc contrib/sdb/ldap/README.ldap contrib/sdb/ldap/INSTALL.ldap contrib/sdb/pgsql/README.sdb_pgsql
%dir %{_sysconfdir}/openldap/schema
%config(noreplace) %{_sysconfdir}/openldap/schema/dnszone.schema
%{_sbindir}/named-sdb
%{_sbindir}/zone2ldap
%{_sbindir}/ldap2zone
%{_sbindir}/zonetodb
%{_sbindir}/zone2sqlite
%endif

%files libs
%defattr(-,root,root,-)
%{_libdir}/*so.*
%exclude %{_libdir}/*export.so.*
%exclude %{_libdir}/*pkcs11.so.*
%exclude %{_libdir}/*pkcs11-export.so.*

%files libs-lite
%defattr(-,root,root,-)
%{_libdir}/*export.so.*
%exclude %{_libdir}/*pkcs11-export.so.*

%files license
%defattr(-,root,root,-)
%doc COPYRIGHT

%files utils
%defattr(-,root,root,-)
%{_bindir}/dig
%{_bindir}/host
%{_bindir}/nslookup
%{_bindir}/nsupdate
%{_mandir}/man1/host.1*
%{_mandir}/man1/nsupdate.1*
%{_mandir}/man1/dig.1*
%{_mandir}/man1/nslookup.1*

%if %{DEVEL}
%files devel
%defattr(-,root,root,-)
%{_libdir}/*so
%exclude %{_libdir}/*export.so
%exclude %{_libdir}/*pkcs11.so
%exclude %{_libdir}/*pkcs11-export.so
%{_includedir}/bind9
%exclude %{_includedir}/bind9/pkcs11
%exclude %{_includedir}/bind9/pk11
%{_mandir}/man1/isc-config.sh.1*
%{_mandir}/man3/lwres*
%{_bindir}/isc-config.sh
%endif

%files lite-devel
%defattr(-,root,root,-)
%{_libdir}/*export.so
%exclude %{_libdir}/*pkcs11-export.so
%{_includedir}/dns
%{_includedir}/dst
%{_includedir}/irs
%{_includedir}/isc
%{_includedir}/isccfg

%if %{PKCS11}
%files pkcs11
%defattr(-,root,root,-)
%{_sbindir}/named-pkcs11
%{_mandir}/man8/named-pkcs11.8*

%files pkcs11-utils
%defattr(-,root,root,-)
%{_sbindir}/dnssec*pkcs11
%{_sbindir}/pkcs11-destroy
%{_sbindir}/pkcs11-keygen
%{_sbindir}/pkcs11-list
%{_sbindir}/pkcs11-tokens
%{_mandir}/man8/pkcs11*.8*
%{_mandir}/man8/dnssec*-pkcs11.8*

%files pkcs11-libs
%defattr(-,root,root,-)
%{_libdir}/*pkcs11.so.*
%{_libdir}/*pkcs11-export.so.*

%files pkcs11-devel
%defattr(-,root,root,-)
%{_includedir}/bind9/pk11
%{_includedir}/bind9/pkcs11
%{_libdir}/*pkcs11.so
%{_libdir}/*pkcs11-export.so
%endif

%changelog
* Fri Sep 23 2016 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-29.4
- Fix CVE-2016-2776

* Tue Mar 08 2016 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-29.3
- Fix CVE-2016-1285 and CVE-2016-1286

* Mon Jan 18 2016 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-29.2
- Fix CVE-2015-8704

* Mon Dec 14 2015 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-29.1
- fixed security isseus
  . CVE-2015-8000
    A denial of service flaw was found in the way BIND processed certain
    records with malformed class attributes. A remote attacker could use this
    flaw to send a query to request a cached record with a malformed class
    attribute that would cause named functioning as an authoritative or
    recursive server to crash.

* Wed Sep 02 2015 JoungKyun.Kim <http://oops.org> - 132:9.9.4-29%{?dist}
- remove chroot package (default chroot mode)
- add geodns patch
  set GEOIP_DATA_COPY="yes" in /etc/sysconfig/named
  https://code.google.com/p/bind-geoip/wiki/UsageGuide

* Wed Sep 02 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-29
- Fix CVE-2015-5722

* Wed Aug 05 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-28
- Increase ISC_SOCKET_MAXEVENTS to 2048 (#1235609)

* Tue Jul 28 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-27
- Fix CVE-2015-5477

* Wed Jul 08 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-26
- Fix CVE-2015-4620

* Tue Jul 07 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-25
- Fixed nsupdate realm auto-detection (#1214827)

* Mon Jun 29 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-24
- Reintroduce the DISABLE_ZONE_CHECKING into /etc/sysconfig/named (#1236475)

* Mon Jun 01 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-23
- Don't copy /etc/localtime on -chroot package installation (#1186773)
- Fix SPF resource records check to comply with RFC7208 (#1215164)
- Don't use ISC's DLV by default (#1223336)

* Fri May 22 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-22
- Add version specific requires on bind for bind-pkcs11 (Related: #1097753)
- Resolve issues found by static analysis (Related: #1097753)

* Thu May 21 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-21
- Added native PKCS#11 functionality (#1097753)

* Wed May 20 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-20
- DNS resolution failure in high load environment with SERVFAIL and "out of memory/success" in the log (#1221180)

* Thu May 14 2015 Tomas Hozza /</thozza@redhat.com/>/ - 32:9.9.4-19
- Install config for tmpfiles under %%{_tmpfilesdir} (#1180976)
- Fixed systemctl path in logrotate configuration (#1164264)
- remove information about system-config-bind from named.8 man page (#1152066)

* Mon Mar 02 2015 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-18.1
- Fix CVE-2015-1349

* Wed Dec 10 2014 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-18
- Fix CVE-2014-8500 (#1171976)

* Thu Sep 18 2014 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-17
- Fix error in dyndb API that can cause named to freeze on shutdown (#1142150)
- Fix error in triggerun scriptlet (#1143033)
- Remove /var/named/chroot/var/run on bind-chroot update if it is a directory (#1091341)

* Thu Aug 21 2014 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-16
- Add versioned requires on bind-libs to bind-utils and bind-sdb

* Wed Aug 20 2014 Tomas Hozza <thozza@redhat.com> - 32:9.9.4-15
- Use /dev/urandom when generating rndc.key file (#1107568)
- Allow authentication using TSIG in allow-notify configuration statement (#1067424)
- Fix race condition when destroying a resolver fetch object (#1072379)
- Increase defaults for lwresd workers and make workers and client objects number configurable (#1098959)
- Configure BIND with --with-dlopen=yes to support dynamically loadable DLZ drivers (#1096688)

* Fri Jan 24 2014 Daniel Mach <dmach@redhat.com> - 32:9.9.4-14
- Mass rebuild 2014-01-24

* Wed Jan 15 2014 Honza Horak <hhorak@redhat.com> - 32:9.9.4-13
- Rebuild for mariadb-libs
  Related: #1045013

* Tue Jan 14 2014 Tomas Hozza <thozza@redhat.com> 32:9.9.4-12
- Fix CVE-2014-0591

* Mon Jan 06 2014 Tomas Hozza <thozza@redhat.com> 32:9.9.4-11
- Build against libdb instead of libdb4 (#1044990)

* Fri Dec 27 2013 Daniel Mach <dmach@redhat.com> - 32:9.9.4-10
- Mass rebuild 2013-12-27

* Wed Dec 18 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-9
- Fix crash in rbtdb after two sucessive getoriginnode() calls (#1044026)

* Tue Dec 17 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-8
- Split chroot package for named and named-sdb
- Extract setting-up/destroying of chroot to a separate systemd service (#1004300)

* Thu Dec 05 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-7
- Create symlink /var/named/chroot/var/run -> /var/named/chroot/run (#1024384)
- Added session-keyfile statement into default named.conf since we use /run/named (#1024384)

* Thu Nov 28 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-6
- Fixed memory leak in nsupdate if 'realm' was used multiple times (#1034824)

* Tue Nov 12 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-5
- Install configuration for rwtab and fix chroot setup script (#1028189)
- use --enable-filter-aaaa when building bind to enable filter-aaaa-on-v4 option (#1025245)

* Thu Oct 31 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-4
- Correct the patch for #1020683

* Tue Oct 29 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-3
- Fix race condition on send buffers in dighost.c (#1020683)

* Tue Oct 08 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-2
- install isc/errno2result.h header (#1015165)

* Mon Sep 23 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.4-1
- update to 9.9.4 (#1010200)
- drop merged patches
- modify patches to fit on new version

* Tue Sep 10 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.3-8.P2
- Fix [ISC-Bugs #34738] dns_journal_open() returns a pointer to stack

* Fri Aug 16 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.3-7.P2
- Don't generate rndc.key if there exists rndc.conf

* Fri Aug 16 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.3-6.P2
- don't install named-sdb.service if SDB macro is defined to zero

* Sun Jul 28 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.3-5.P2
- update to 9.9.3-P2 (fix for CVE-2013-4854)
- update RRL patch to 9.9.3-P2-rl.13207.22
- Fix script for setting up chroot so it unmounts everything successfully

* Wed Jul 10 2013 Tomas Hozza <thozza@redhat.com> 32:9.9.3-4.P1
- Fix dates in Changelog
